"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const vue = require("vue");
const injectionJs = require("injection-js");
function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof2(obj2) {
      return typeof obj2;
    };
  } else {
    _typeof = function _typeof2(obj2) {
      return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    };
  }
  return _typeof(obj);
}
function boundMethod(target, key, descriptor) {
  var fn = descriptor.value;
  if (typeof fn !== "function") {
    throw new TypeError("@boundMethod decorator can only be applied to methods not: ".concat(_typeof(fn)));
  }
  var definingProperty = false;
  return {
    configurable: true,
    get: function get() {
      if (definingProperty || this === target.prototype || this.hasOwnProperty(key) || typeof fn !== "function") {
        return fn;
      }
      var boundFn = fn.bind(this);
      definingProperty = true;
      Object.defineProperty(this, key, {
        configurable: true,
        get: function get2() {
          return boundFn;
        },
        set: function set(value) {
          fn = value;
          delete this[key];
        }
      });
      definingProperty = false;
      return boundFn;
    },
    set: function set(value) {
      fn = value;
    }
  };
}
function boundClass(target) {
  var keys;
  if (typeof Reflect !== "undefined" && typeof Reflect.ownKeys === "function") {
    keys = Reflect.ownKeys(target.prototype);
  } else {
    keys = Object.getOwnPropertyNames(target.prototype);
    if (typeof Object.getOwnPropertySymbols === "function") {
      keys = keys.concat(Object.getOwnPropertySymbols(target.prototype));
    }
  }
  keys.forEach(function(key) {
    if (key === "constructor") {
      return;
    }
    var descriptor = Object.getOwnPropertyDescriptor(target.prototype, key);
    if (typeof descriptor.value === "function") {
      Object.defineProperty(target.prototype, key, boundMethod(target, key, descriptor));
    }
  });
  return target;
}
function autobind() {
  if (arguments.length === 1) {
    return boundClass.apply(void 0, arguments);
  }
  return boundMethod.apply(void 0, arguments);
}
function Autobind() {
  return autobind;
}
function useProps() {
  const instance = vue.getCurrentInstance();
  return instance == null ? void 0 : instance.props;
}
function useCtx() {
  const instance = vue.getCurrentInstance();
  return instance == null ? void 0 : instance.setupContext;
}
function getCurrentApp() {
  var _a;
  return (_a = vue.getCurrentInstance()) == null ? void 0 : _a.appContext.app;
}
function getEmitsFromProps(defaultProps) {
  const keys = Array.isArray(defaultProps) ? defaultProps : Object.keys(defaultProps);
  const emits = [];
  for (let key of keys) {
    if (!/^on/.test(key))
      continue;
    key = key.slice(2).replace(/Once$/, "");
    emits.push(key[0].toLowerCase() + key.slice(1));
  }
  return emits;
}
function createSymbol(name) {
  return typeof Symbol === "undefined" ? name : Symbol(name);
}
function createDecorator(name, allowRepeat = false) {
  const metaName = `VUE3-OOP_${name.toUpperCase()}`;
  const MetadataKey2 = createSymbol(metaName);
  const decoratorFn = function(options) {
    return function(target, key) {
      let list = Reflect.getMetadata(MetadataKey2, target) || [];
      list = list.slice();
      const hasIndex = list.findIndex((k) => k.key === key);
      if (hasIndex === -1) {
        list.push({ key, options: allowRepeat ? [options] : options });
      } else {
        const item = Object.assign({}, list[hasIndex]);
        if (!allowRepeat) {
          item.options = options;
        } else if (Array.isArray(item.options)) {
          item.options = item.options.concat(options);
        }
        list[hasIndex] = item;
      }
      Reflect.defineMetadata(MetadataKey2, list, target);
    };
  };
  decoratorFn.MetadataKey = MetadataKey2;
  Object.defineProperty(decoratorFn, "MetadataKey", {
    get() {
      return MetadataKey2;
    }
  });
  return decoratorFn;
}
function getProtoMetadata(target, key, withDesc = false) {
  const proto = Object.getPrototypeOf(target);
  if (!proto)
    return [];
  const res = Reflect.getMetadata(key, proto) || [];
  if (withDesc) {
    res.forEach((k) => k.desc = getDeepOwnDescriptor(proto, k.key));
  }
  return res;
}
function getDeepOwnDescriptor(proto, key) {
  if (!proto)
    return null;
  const desc = Object.getOwnPropertyDescriptor(proto, key);
  if (desc)
    return desc;
  return getDeepOwnDescriptor(Object.getPrototypeOf(proto), key);
}
const Mut = createDecorator("Mut");
function handler$3(targetThis) {
  const list = getProtoMetadata(targetThis, Mut.MetadataKey);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const { options, key } = item;
    let keyVal;
    if (options === true) {
      keyVal = vue.shallowRef();
    } else if (typeof options === "function") {
      keyVal = vue.customRef(options);
    } else {
      keyVal = vue.ref();
    }
    Object.defineProperty(targetThis, key, {
      enumerable: true,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const MutHandler = {
  key: "Mut",
  handler: handler$3
};
const Computed = createDecorator("Computed");
function handler$2(targetThis) {
  const list = getProtoMetadata(
    targetThis,
    Computed.MetadataKey,
    true
  );
  if (!list || !list.length)
    return;
  for (const item of list) {
    const desc = item.desc;
    const option = item.options;
    if (!desc)
      continue;
    let keyVal;
    if (option) {
      keyVal = vue.shallowRef();
      vue.watchEffect(
        () => {
          var _a;
          try {
            keyVal.value = (_a = desc.get) == null ? void 0 : _a.call(targetThis);
          } finally {
          }
        },
        {
          flush: option === true ? "sync" : option
        }
      );
    } else {
      keyVal = vue.computed({
        get: () => {
          var _a;
          return (_a = desc.get) == null ? void 0 : _a.call(targetThis);
        },
        set: (v) => {
          var _a;
          return (_a = desc.set) == null ? void 0 : _a.call(targetThis, v);
        }
      });
    }
    Object.defineProperty(targetThis, item.key, {
      enumerable: desc == null ? void 0 : desc.enumerable,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const ComputedHandler = {
  key: "Computed",
  handler: handler$2
};
const Hook = createDecorator("Hook", true);
function handler$1(targetThis) {
  const list = getProtoMetadata(
    targetThis,
    Hook.MetadataKey
  );
  if (!(list == null ? void 0 : list.length))
    return;
  for (const item of list) {
    let vueFn;
    const doneLife = {};
    const options = item.options.slice();
    for (const option of options) {
      if (Array.isArray(option)) {
        options.push(...option);
        continue;
      }
      if (doneLife[option])
        continue;
      switch (option) {
        case "BeforeMount":
          vueFn = vue.onBeforeMount;
          break;
        case "Mounted":
          vueFn = vue.onMounted;
          break;
        case "BeforeUpdate":
          vueFn = vue.onBeforeUpdate;
          break;
        case "Updated":
          vueFn = vue.onUpdated;
          break;
        case "BeforeUnmount":
          vueFn = vue.onBeforeUnmount;
          break;
        case "Unmounted":
          vueFn = vue.onUnmounted;
          break;
        case "Activated":
          vueFn = vue.onActivated;
          break;
        case "Deactivated":
          vueFn = vue.onDeactivated;
          break;
        case "ErrorCaptured":
          vueFn = vue.onErrorCaptured;
          break;
        case "RenderTracked":
          vueFn = vue.onRenderTracked;
          break;
        case "RenderTriggered":
          vueFn = vue.onRenderTriggered;
          break;
        case "ServerPrefetch":
          vueFn = vue.onServerPrefetch;
          break;
      }
      doneLife[option] = true;
      vueFn((...args) => targetThis[item.key](...args));
    }
  }
}
const HookHandler = {
  key: "Hook",
  handler: handler$1
};
const Link = createDecorator("Link");
function handler(targetThis) {
  const list = getProtoMetadata(
    targetThis,
    Link.MetadataKey
  );
  if (!list || !list.length)
    return;
  for (const item of list) {
    const { key, options } = item;
    const instance = vue.getCurrentInstance();
    Object.defineProperty(targetThis, key, {
      enumerable: true,
      configurable: true,
      get() {
        var _a;
        return (_a = instance == null ? void 0 : instance.refs) == null ? void 0 : _a[options || key];
      }
    });
  }
}
const LinkHandler = {
  key: "Link",
  handler
};
const InjectorKey = createSymbol(
  "VUE3-OOP_ReflectiveInjector"
);
const MetadataKey = createSymbol("VUE3-OOP_Component");
const MetadataProviderKey = createSymbol("VUE3-OOP_ResolveProviders");
function Component(options) {
  return function(target) {
    Reflect.defineMetadata(MetadataKey, options, target);
    return injectionJs.Injectable()(target);
  };
}
function resolveComponent(target) {
  var _a, _b;
  if (!Reflect.getMetadata("annotations", target))
    return new target();
  const parent = vue.inject(InjectorKey, void 0);
  let resolveProviders = Reflect.getOwnMetadata(
    MetadataProviderKey,
    target
  );
  const options = Reflect.getOwnMetadata(
    MetadataKey,
    target
  );
  if (!resolveProviders || (options == null ? void 0 : options.stable) === false) {
    let deps = [target];
    if ((_a = options == null ? void 0 : options.providers) == null ? void 0 : _a.length) {
      deps = deps.concat(options.providers);
    }
    if ((options == null ? void 0 : options.autoResolveDeps) !== false) {
      deps = resolveDependencies(deps);
    }
    if ((_b = options == null ? void 0 : options.exclude) == null ? void 0 : _b.length) {
      deps = deps.filter((k) => {
        var _a2;
        return !((_a2 = options.exclude) == null ? void 0 : _a2.includes(k));
      });
    }
    resolveProviders = injectionJs.ReflectiveInjector.resolve(deps);
    Reflect.defineMetadata(MetadataProviderKey, resolveProviders, target);
  }
  const injector = injectionJs.ReflectiveInjector.fromResolvedProviders(
    resolveProviders,
    parent
  );
  if (options == null ? void 0 : options.globalStore) {
    const current = vue.getCurrentInstance();
    const app = current.appContext.app;
    app.provide(InjectorKey, injector);
    app.getStore = () => injector;
    app.getService = (token) => injector.get(token);
  } else {
    vue.provide(InjectorKey, injector);
  }
  const compInstance = injector.get(target);
  resolveProviders.forEach((k) => injector.get(k.key.token));
  return compInstance;
}
function resolveDependencies(inputs) {
  const noConstructor = [];
  for (const input of inputs) {
    if (!(input instanceof Function) && !Array.isArray(input)) {
      noConstructor.push(input);
    }
  }
  const deps = /* @__PURE__ */ new Set();
  function resolver(klass) {
    if (deps.has(klass) || noConstructor.find((k) => k !== klass && k.provide === klass))
      return;
    deps.add(klass);
    const resolves = injectionJs.ReflectiveInjector.resolve([klass]);
    for (const item of resolves) {
      for (const fact of item.resolvedFactories) {
        for (const dep of fact.dependencies) {
          if (dep.optional || dep.visibility instanceof injectionJs.SkipSelf || dep.key.token instanceof injectionJs.InjectionToken || typeof dep.key.token !== "function") {
            continue;
          }
          resolver(dep.key.token);
        }
      }
    }
  }
  for (const input of inputs)
    resolver(input);
  return Array.from(deps);
}
function getCurrentInjector() {
  const instance = vue.getCurrentInstance();
  return instance.provides[InjectorKey] || vue.inject(InjectorKey);
}
function createCurrentInjector(providers, exclude) {
  let deps = resolveDependencies(providers);
  if (exclude == null ? void 0 : exclude.length) {
    deps = deps.filter((k) => exclude == null ? void 0 : exclude.includes(k));
  }
  const resolveProviders = injectionJs.ReflectiveInjector.resolve(deps);
  const parent = vue.inject(InjectorKey, void 0);
  const injector = injectionJs.ReflectiveInjector.fromResolvedProviders(
    resolveProviders,
    parent
  );
  vue.provide(InjectorKey, injector);
  resolveProviders.forEach((k) => injector.get(k.key.token));
  return injector;
}
function injectService(token, notFoundValue) {
  const currentInjector = getCurrentInjector();
  if (!currentInjector)
    return notFoundValue;
  return currentInjector.get(token, notFoundValue);
}
const GlobalStoreKey = "GlobalStoreKey";
const hasOwnProperty = Object.prototype.hasOwnProperty;
const hasOwn = (val, key) => hasOwnProperty.call(val, key);
const _VueComponent = class {
  constructor() {
    this.props = useProps();
    this.context = useCtx();
    this.$ = vue.getCurrentInstance();
    vue.markRaw(this);
    const current = this.$;
    current.exposed = this;
    current.exposeProxy = this;
    const ThisConstructor = this.constructor;
    if (ThisConstructor.globalStore) {
      const app = current.appContext.app;
      app.provide(GlobalStoreKey, this);
      app.getStore = () => this;
      app.getService = (token) => {
        if ((typeof token === "function" || typeof token === "object") && "ProviderKey" in token) {
          token = token.ProviderKey;
        }
        return current == null ? void 0 : current.provides[token];
      };
    }
    _VueComponent.handler.forEach((handler2) => handler2.handler(this));
  }
  get $props() {
    return this.props;
  }
  get $el() {
    return this.$.proxy.$el;
  }
  get $data() {
    return this.$.proxy.$data;
  }
  get $attrs() {
    return this.$.proxy.$attrs;
  }
  get $slots() {
    return this.$.proxy.$slots;
  }
  get $options() {
    return this.$.proxy.$options;
  }
  get $refs() {
    return this.$.proxy.$refs;
  }
  get $parent() {
    return this.$.proxy.$parent;
  }
  get $root() {
    return this.$.proxy.$root;
  }
  get $emit() {
    return this.$.proxy.$emit;
  }
  get $forceUpdate() {
    return this.$.proxy.$forceUpdate;
  }
  get $nextTick() {
    return this.$.proxy.$nextTick;
  }
  get $watch() {
    return this.$.proxy.$watch;
  }
};
let VueComponent = _VueComponent;
VueComponent.handler = [
  MutHandler,
  ComputedHandler,
  LinkHandler,
  HookHandler
];
VueComponent.resolveComponent = resolveComponent;
Object.defineProperty(VueComponent, "__vccOpts", {
  enumerable: true,
  configurable: true,
  get() {
    if (this === VueComponent) {
      console.warn("base VueComponent only to be extends");
      return;
    }
    if (hasOwn(this, "__vccOpts__value"))
      return this.__vccOpts__value;
    const parent = Object.getPrototypeOf(this);
    const parentOpt = parent === VueComponent ? null : parent.__vccOpts;
    const CompConstructor = this;
    const _a = CompConstructor, { displayName, defaultProps, emits } = _a, rest = __objRest(_a, ["displayName", "defaultProps", "emits"]);
    let optValue;
    const setup = (props, ctx) => {
      const instance = VueComponent.resolveComponent(CompConstructor);
      if (CompConstructor.__vccOpts__value.render)
        return instance;
      const render = instance.render.bind(instance);
      if (typeof instance.init === "function") {
        const res = instance.init();
        if (typeof (res == null ? void 0 : res.then) === "function" && CompConstructor.async) {
          return res.then(() => render);
        }
      }
      vue.getCurrentInstance().data = instance;
      return render;
    };
    if (parentOpt) {
      optValue = __spreadProps(__spreadValues(__spreadValues({}, parentOpt), rest), {
        name: displayName || CompConstructor.name,
        setup
      });
      if (defaultProps)
        optValue.props = defaultProps;
      if (emits)
        optValue.emits = emits;
    } else {
      optValue = __spreadProps(__spreadValues({}, rest), {
        name: displayName || CompConstructor.name,
        props: defaultProps || {},
        emits: (emits || []).concat(
          getEmitsFromProps(CompConstructor.defaultProps || {})
        ),
        setup
      });
    }
    Object.defineProperty(this, "__vccOpts__value", {
      configurable: true,
      enumerable: false,
      value: optValue,
      writable: true
    });
    return optValue;
  }
});
function useForwardRef() {
  const instance = vue.getCurrentInstance();
  function forwardRef(ref) {
    instance.exposed = ref;
    instance.exposeProxy = ref;
  }
  return forwardRef;
}
function mergeRefs(...values) {
  return function(ref, refs) {
    for (const r of values) {
      if (typeof r === "string") {
        refs[r] = ref;
      } else if (typeof r === "function") {
        r(ref, refs);
      } else if (vue.isRef(r)) {
        r.value = ref;
      }
    }
  };
}
const _VueService = class {
  constructor() {
    vue.markRaw(this);
    _VueService.handler.forEach((handler2) => handler2.handler(this));
  }
};
let VueService = _VueService;
VueService.handler = [
  MutHandler,
  ComputedHandler,
  LinkHandler,
  HookHandler
];
exports.Autobind = Autobind;
exports.Component = Component;
exports.Computed = Computed;
exports.GlobalStoreKey = GlobalStoreKey;
exports.Hook = Hook;
exports.InjectorKey = InjectorKey;
exports.Link = Link;
exports.Mut = Mut;
exports.VueComponent = VueComponent;
exports.VueService = VueService;
exports.createCurrentInjector = createCurrentInjector;
exports.createDecorator = createDecorator;
exports.createSymbol = createSymbol;
exports.getCurrentApp = getCurrentApp;
exports.getCurrentInjector = getCurrentInjector;
exports.getEmitsFromProps = getEmitsFromProps;
exports.getProtoMetadata = getProtoMetadata;
exports.injectService = injectService;
exports.mergeRefs = mergeRefs;
exports.useCtx = useCtx;
exports.useForwardRef = useForwardRef;
exports.useProps = useProps;
//# sourceMappingURL=vue3-oop.js.map
