export interface DecoratorFn<T, IsMethod = false> {
    (options: T): IsMethod extends false ? PropertyDecorator : MethodDecorator;
    MetadataKey: string | symbol;
}
export interface MetadataStore<T> {
    key: string | symbol;
    options: T;
    desc?: PropertyDescriptor | null;
}
export declare function createDecorator<T = void>(name: string, allowRepeat?: boolean): DecoratorFn<T, false>;
export declare function getProtoMetadata<T = void>(target: any, key: symbol | string, withDesc?: boolean): MetadataStore<T>[];
export declare function getDeepOwnDescriptor(proto: any, key: string | symbol): PropertyDescriptor | null;
