import type { ComponentOptions, ComponentPublicInstance, VNodeChild, VNodeRef } from 'vue';
import type { Hanlder, VueComponentProps, WithSlotTypes } from '../type';
import { resolveComponent } from '../di';
export declare const GlobalStoreKey = "GlobalStoreKey";
export declare class VueComponent<T extends {} = {}> {
    /** 装饰器处理 */
    static handler: Hanlder[];
    /** 是否自定义解析组件 */
    static resolveComponent: typeof resolveComponent;
    /** 热更新使用 */
    static __hmrId?: string;
    /** 组件显示名字 */
    static displayName?: string;
    /** 组件的属性定义 */
    static defaultProps?: any;
    /** vue options emits */
    static emits?: string[];
    /**
     * 是否继承多余的属性
     */
    static inheritAttrs?: boolean;
    static __vccOpts__value?: ComponentOptions;
    /** 组件option定义,vue3遇到类组件会从此属性获取组件的option */
    static __vccOpts: ComponentOptions;
    /** 是否作为全局store提供外部入口，此时会在 当前app上注入2个方法，用于获取此组件的服务 */
    static globalStore?: boolean;
    /** 组件属性 */
    props: VueComponentProps<T>;
    /** 组件上下文 */
    context: WithSlotTypes<T>;
    /** 组件内部实例，如果使用组件实例请 this.$.proxy */
    $: import("vue").ComponentInternalInstance;
    /** 主要给jsx提示用 */
    get $props(): VueComponentProps<T>;
    get $el(): any;
    get $data(): {};
    get $attrs(): {
        [x: string]: unknown;
    };
    get $slots(): Readonly<{
        [name: string]: import("vue").Slot | undefined;
    }>;
    get $options(): import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}> & {
        beforeCreate?: ((() => void) | (() => void)[]) | undefined;
        created?: ((() => void) | (() => void)[]) | undefined;
        beforeMount?: ((() => void) | (() => void)[]) | undefined;
        mounted?: ((() => void) | (() => void)[]) | undefined;
        beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
        updated?: ((() => void) | (() => void)[]) | undefined;
        activated?: ((() => void) | (() => void)[]) | undefined;
        deactivated?: ((() => void) | (() => void)[]) | undefined;
        beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
        beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
        destroyed?: ((() => void) | (() => void)[]) | undefined;
        unmounted?: ((() => void) | (() => void)[]) | undefined;
        renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
        renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
        errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
    };
    get $refs(): {
        [x: string]: unknown;
    };
    get $parent(): ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
    get $root(): ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
    get $emit(): (event: string, ...args: any[]) => void;
    get $forceUpdate(): () => void;
    get $nextTick(): typeof import("vue").nextTick;
    get $watch(): (source: string | Function, cb: Function, options?: import("vue").WatchOptions<boolean> | undefined) => import("vue").WatchStopHandle;
    constructor();
    /** 渲染函数 */
    render?(ctx: ComponentPublicInstance, cache: any[]): VNodeChild;
    /**
     * 组件初始化逻辑
     * 如果设置 static async = true,并且返回promise则为异步setup组件
     * 需配合 suspense 组件使用
     */
    init?(): any;
    /**
     * 标记为异步初始化组件, 配合init使用
     */
    static async?: boolean;
}
export declare function useForwardRef(): (ref: any) => void;
export declare function mergeRefs(...values: VNodeRef[]): (ref: Element | ComponentPublicInstance | null, refs: Record<string, any>) => void;
